'''
Created on Mar 25, 2016

@author: mukuze
'''
'''
Some important data is initialized here and it is accessed by
all other parts of the system which update it. This data is shared across modules. This 
is basically an implementation of the global variables idea with the added property to be sharable
among all modules in the program. This could be also viewed as a part of the model in the Model-View-Controller architectural pattern of software design 
'''

# data need for all the data processing of the application
number_columns_=0
number_rows_=0
indices_=[]
temp_perm_mat_=[]
perm_mat_=[]
perm_row_=[]
indices_1s_=[]
full_mat_=[]
clitems_=[]
trans_sets_=[]
number_1s_={}
factoritems_=[]
cover_={}
reduced_index_cover_={}
scores_factors_={}
factorindx_=0
factor_pair_merge_=()
add_info_=""
user_choose_=""
merging_operation_=""
acc_error_=0
error_recommended_operation_=0

# temporal data awaiting to be committed by the user
clitems_temp=[]
trans_sets_temp=[]
factoritems_temp=[]
reduced_index_cover_temp={}
scores_factors_temp={}
number_1s_temp={}

# global variables that contain the factor items indexes ordered in increasing number of 1s they cover alone
# and the similar pairs
similar_pairs_=()
ordered_factors_items_=[]

# variables to keep the errors of the recommended operations so we need not recompute these errors
# these are dictionaries with the keys equal to the recommended factor to delete index or most similar pair and values the errors one would incur in committing the operation
# in the case of the errors for the similar pairs the value is a tuple with the first element indicating the error of a merge with OR and the second element a merge with AND
error_index_delete_={}
error_similar_pair_={}

# global variable to decide if the y axis labels are shown or not
# it is set to zero cause on the mammals data we do not want to see these labels
# for a data that requires that, reset it to True
show_ylabels=True


